#!/usr/local/bin/perl -w

$up = 50;
$dw = 30;#caution dw < 60! (if dw>60, check all script!)

$seqfile ="NC_000913.fna";
open(SEQ, $seqfile) || die "Can't open $seqfile :$!\n";
$all_seq = "";
while(<SEQ>){
	chomp;
	$all_seq .= $_ unless(/^>/);
}
close(SEQ);
	
$aaseqfile = "EcoGene17.lib";
	
$infile = "EG858_dataset";	#experimentally validated data
open(IN, $infile) || die "Can't open $infile :$!\n";
	
$outfile = "EG858_up".$up."_dw".$dw;
open(OUT, ">$outfile") || die "Can't open $outfile :$!\n";

while(<IN>){
	chomp;
	@gene = split("\t");
	open(AA, $aaseqfile) || die "Can't open $aaseqfile :$!\n";
	while(<AA>){
		next unless(/$gene[0]/);
		$seq = <AA>;
		chomp($seq);
		last;
	}
	$upseq = "";
	if($all_seq =~ /$seq/){
		$_ = $all_seq;
		($upseq) = /(\w{$up})$seq/;
	}else{
		$_ = $all_seq;
		$compl = reverse($seq);
		$compl =~ tr/ATGC/TACG/;
		($upseq) = /$compl(\w{$up})/;
		$upseq = reverse($upseq);
		$upseq =~ tr/ATGC/TACG/;
	}
	$_ = $seq;
	($dwseq) = /^(\w{$dw})/;
#	print OUT ">$gene[0]\n$upseq$dwseq\n";	#for FASTA format
	print OUT "$gene[0]\t$gene[1]\t$upseq$dwseq\n";
}
