#!/usr/local/bin/perl -w
###
#	2nd order Mrackov model.
###
#Ecoli 2nd order Markov Model
$BGaaa = 0.0220;
$BGaac = 0.0177;
$BGaag = 0.0133;
$BGaat = 0.0169;
$BGaca = 0.0121;
$BGacc = 0.0166;
$BGacg = 0.0163;
$BGact = 0.0106;
$BGaga = 0.0118;
$BGagc = 0.0180;
$BGagg = 0.0105;
$BGagt = 0.0106;
$BGata = 0.0125;
$BGatc = 0.0188;
$BGatg = 0.0164;
$BGatt = 0.0169;
$BGcaa = 0.0164;
$BGcac = 0.0147;
$BGcag = 0.0232;
$BGcat = 0.0164;
$BGcca = 0.0194;
$BGccc = 0.0102;
$BGccg = 0.0195;
$BGcct = 0.0105;
$BGcga = 0.0160;
$BGcgc = 0.0262;
$BGcgg = 0.0195;
$BGcgt = 0.0163;
$BGcta = 0.0054;
$BGctc = 0.0089;
$BGctg = 0.0232;
$BGctt = 0.0133;
$BGgaa = 0.0181;
$BGgac = 0.0120;
$BGgag = 0.0089;
$BGgat = 0.0188;
$BGgca = 0.0212;
$BGgcc = 0.0208;
$BGgcg = 0.0262;
$BGgct = 0.0180;
$BGgga = 0.0120;
$BGggc = 0.0208;
$BGggg = 0.0102;
$BGggt = 0.0166;
$BGgta = 0.0112;
$BGgtc = 0.0120;
$BGgtg = 0.0147;
$BGgtt = 0.0177;
$BGtaa = 0.0134;
$BGtac = 0.0112;
$BGtag = 0.0054;
$BGtat = 0.0125;
$BGtca = 0.0180;
$BGtcc = 0.0120;
$BGtcg = 0.0160;
$BGtct = 0.0118;
$BGtga = 0.0180;
$BGtgc = 0.0212;
$BGtgg = 0.0194;
$BGtgt = 0.0121;
$BGtta = 0.0134;
$BGttc = 0.0181;
$BGttg = 0.0164;
$BGttt = 0.0220;
$seq = "";
$N =0;

$fas_folder = "align_fasta";
opendir(DIR, $fas_folder) || die "Can't open $fas_folder :$!\n";
@fass = grep /\.fas/, readdir(DIR);

foreach $fas (@fass){
	$fasfile = $fas;
	$tf = $fasfile;
	$tf =~ s/\.fas//;
	$outfile = "align_matrix/$tf"."_align.txt";

	open(FASTA,"$fas_folder\/$fasfile") || die"Can't open $fasfile\n";
	open(OUT,">$outfile") || die"Can't open $outfile\n";

#	print OUT ">$tf\n";
	$fg = 0;
	while(<FASTA>){
		next if(/^>/);
		$N ++;	#the number of sequeces
		chomp;
		$seq = $_;
		$len = length $seq;
		
		#initialize
		if($fg == 0){
			$fg = 1;
			foreach $i (0..$len-3){
#				$fg[$i] = 0;
				$AAA[$i] = $AAT[$i] = $AAG[$i] = $AAC[$i] = $ATA[$i] = $ATT[$i] = $ATG[$i] = $ATC[$i] = $AGA[$i] = $AGT[$i] = $AGG[$i] = $AGC[$i] = $ACA[$i] = $ACT[$i] = $ACG[$i] = $ACC[$i] = $TAA[$i] = $TAT[$i] = $TAG[$i] = $TAC[$i] = $TTA[$i] = $TTT[$i] = $TTG[$i] = $TTC[$i] = $TGA[$i] = $TGT[$i] = $TGG[$i] = $TGC[$i] = $TCA[$i] = $TCT[$i] = $TCG[$i] = $TCC[$i] = $GAA[$i] = $GAT[$i] = $GAG[$i] = $GAC[$i] = $GTA[$i] = $GTT[$i] = $GTG[$i] = $GTC[$i] = $GGA[$i] = $GGT[$i] = $GGG[$i] = $GGC[$i] = $GCA[$i] = $GCT[$i] = $GCG[$i] = $GCC[$i] = $CAA[$i] = $CAT[$i] = $CAG[$i] = $CAC[$i] = $CTA[$i] = $CTT[$i] = $CTG[$i] = $CTC[$i] = $CGA[$i] = $CGT[$i] = $CGG[$i] = $CGC[$i] = $CCA[$i] = $CCT[$i] = $CCG[$i] = $CCC[$i] = 0;
			}
		}
			
		foreach $i (0..$len-3){
			$seqNT = substr($seq,$i,3);
			$AAA[$i]++ if($seqNT eq "AAA");
			$AAT[$i]++ if($seqNT eq "AAT");
			$AAG[$i]++ if($seqNT eq "AAG");
			$AAC[$i]++ if($seqNT eq "AAC");
			$ATA[$i]++ if($seqNT eq "ATA");
			$ATT[$i]++ if($seqNT eq "ATT");
			$ATG[$i]++ if($seqNT eq "ATG");
			$ATC[$i]++ if($seqNT eq "ATC");
			$AGA[$i]++ if($seqNT eq "AGA");
			$AGT[$i]++ if($seqNT eq "AGT");
			$AGG[$i]++ if($seqNT eq "AGG");
			$AGC[$i]++ if($seqNT eq "AGC");
			$ACA[$i]++ if($seqNT eq "ACA");
			$ACT[$i]++ if($seqNT eq "ACT");
			$ACG[$i]++ if($seqNT eq "ACG");
			$ACC[$i]++ if($seqNT eq "ACC");
			$TAA[$i]++ if($seqNT eq "TAA");
			$TAT[$i]++ if($seqNT eq "TAT");
			$TAG[$i]++ if($seqNT eq "TAG");
			$TAC[$i]++ if($seqNT eq "TAC");
			$TTA[$i]++ if($seqNT eq "TTA");
			$TTT[$i]++ if($seqNT eq "TTT");
			$TTG[$i]++ if($seqNT eq "TTG");
			$TTC[$i]++ if($seqNT eq "TTC");
			$TGA[$i]++ if($seqNT eq "TGA");
			$TGT[$i]++ if($seqNT eq "TGT");
			$TGG[$i]++ if($seqNT eq "TGG");
			$TGC[$i]++ if($seqNT eq "TGC");
			$TCA[$i]++ if($seqNT eq "TCA");
			$TCT[$i]++ if($seqNT eq "TCT");
			$TCG[$i]++ if($seqNT eq "TCG");
			$TCC[$i]++ if($seqNT eq "TCC");
			$GAA[$i]++ if($seqNT eq "GAA");
			$GAT[$i]++ if($seqNT eq "GAT");
			$GAG[$i]++ if($seqNT eq "GAG");
			$GAC[$i]++ if($seqNT eq "GAC");
			$GTA[$i]++ if($seqNT eq "GTA");
			$GTT[$i]++ if($seqNT eq "GTT");
			$GTG[$i]++ if($seqNT eq "GTG");
			$GTC[$i]++ if($seqNT eq "GTC");
			$GGA[$i]++ if($seqNT eq "GGA");
			$GGT[$i]++ if($seqNT eq "GGT");
			$GGG[$i]++ if($seqNT eq "GGG");
			$GGC[$i]++ if($seqNT eq "GGC");
			$GCA[$i]++ if($seqNT eq "GCA");
			$GCT[$i]++ if($seqNT eq "GCT");
			$GCG[$i]++ if($seqNT eq "GCG");
			$GCC[$i]++ if($seqNT eq "GCC");
			$CAA[$i]++ if($seqNT eq "CAA");
			$CAT[$i]++ if($seqNT eq "CAT");
			$CAG[$i]++ if($seqNT eq "CAG");
			$CAC[$i]++ if($seqNT eq "CAC");
			$CTA[$i]++ if($seqNT eq "CTA");
			$CTT[$i]++ if($seqNT eq "CTT");
			$CTG[$i]++ if($seqNT eq "CTG");
			$CTC[$i]++ if($seqNT eq "CTC");
			$CGA[$i]++ if($seqNT eq "CGA");
			$CGT[$i]++ if($seqNT eq "CGT");
			$CGG[$i]++ if($seqNT eq "CGG");
			$CGC[$i]++ if($seqNT eq "CGC");
			$CCA[$i]++ if($seqNT eq "CCA");
			$CCT[$i]++ if($seqNT eq "CCT");
			$CCG[$i]++ if($seqNT eq "CCG");
			$CCC[$i]++ if($seqNT eq "CCC");
#			$fg[$i] = 1 if($seqNT eq "N");
		}
	}
	
	$B = log($N);
#	$B = 1;
	
	foreach $i (0..$len-3){
		$Saaa = log((($AAA[$i]+$B*$BGaaa)/($N+$B)) / $BGaaa);
		$Saat = log((($AAT[$i]+$B*$BGaat)/($N+$B)) / $BGaat);
		$Saag = log((($AAG[$i]+$B*$BGaag)/($N+$B)) / $BGaag);
		$Saac = log((($AAC[$i]+$B*$BGaac)/($N+$B)) / $BGaac);
		$Sata = log((($ATA[$i]+$B*$BGata)/($N+$B)) / $BGata);
		$Satt = log((($ATT[$i]+$B*$BGatt)/($N+$B)) / $BGatt);
		$Satg = log((($ATG[$i]+$B*$BGatg)/($N+$B)) / $BGatg);
		$Satc = log((($ATC[$i]+$B*$BGatc)/($N+$B)) / $BGatc);
		$Saga = log((($AGA[$i]+$B*$BGaga)/($N+$B)) / $BGaga);
		$Sagt = log((($AGT[$i]+$B*$BGagt)/($N+$B)) / $BGagt);
		$Sagg = log((($AGG[$i]+$B*$BGagg)/($N+$B)) / $BGagg);
		$Sagc = log((($AGC[$i]+$B*$BGagc)/($N+$B)) / $BGagc);
		$Saca = log((($ACA[$i]+$B*$BGaca)/($N+$B)) / $BGaca);
		$Sact = log((($ACT[$i]+$B*$BGact)/($N+$B)) / $BGact);
		$Sacg = log((($ACG[$i]+$B*$BGacg)/($N+$B)) / $BGacg);
		$Sacc = log((($ACC[$i]+$B*$BGacc)/($N+$B)) / $BGacc);
		$Staa = log((($TAA[$i]+$B*$BGtaa)/($N+$B)) / $BGtaa);
		$Stat = log((($TAT[$i]+$B*$BGtat)/($N+$B)) / $BGtat);
		$Stag = log((($TAG[$i]+$B*$BGtag)/($N+$B)) / $BGtag);
		$Stac = log((($TAC[$i]+$B*$BGtac)/($N+$B)) / $BGtac);
		$Stta = log((($TTA[$i]+$B*$BGtta)/($N+$B)) / $BGtta);
		$Sttt = log((($TTT[$i]+$B*$BGttt)/($N+$B)) / $BGttt);
		$Sttg = log((($TTG[$i]+$B*$BGttg)/($N+$B)) / $BGttg);
		$Sttc = log((($TTC[$i]+$B*$BGttc)/($N+$B)) / $BGttc);
		$Stga = log((($TGA[$i]+$B*$BGtga)/($N+$B)) / $BGtga);
		$Stgt = log((($TGT[$i]+$B*$BGtgt)/($N+$B)) / $BGtgt);
		$Stgg = log((($TGG[$i]+$B*$BGtgg)/($N+$B)) / $BGtgg);
		$Stgc = log((($TGC[$i]+$B*$BGtgc)/($N+$B)) / $BGtgc);
		$Stca = log((($TCA[$i]+$B*$BGtca)/($N+$B)) / $BGtca);
		$Stct = log((($TCT[$i]+$B*$BGtct)/($N+$B)) / $BGtct);
		$Stcg = log((($TCG[$i]+$B*$BGtcg)/($N+$B)) / $BGtcg);
		$Stcc = log((($TCC[$i]+$B*$BGtcc)/($N+$B)) / $BGtcc);
		$Sgaa = log((($GAA[$i]+$B*$BGgaa)/($N+$B)) / $BGgaa);
		$Sgat = log((($GAT[$i]+$B*$BGgat)/($N+$B)) / $BGgat);
		$Sgag = log((($GAG[$i]+$B*$BGgag)/($N+$B)) / $BGgag);
		$Sgac = log((($GAC[$i]+$B*$BGgac)/($N+$B)) / $BGgac);
		$Sgta = log((($GTA[$i]+$B*$BGgta)/($N+$B)) / $BGgta);
		$Sgtt = log((($GTT[$i]+$B*$BGgtt)/($N+$B)) / $BGgtt);
		$Sgtg = log((($GTG[$i]+$B*$BGgtg)/($N+$B)) / $BGgtg);
		$Sgtc = log((($GTC[$i]+$B*$BGgtc)/($N+$B)) / $BGgtc);
		$Sgga = log((($GGA[$i]+$B*$BGgga)/($N+$B)) / $BGgga);
		$Sggt = log((($GGT[$i]+$B*$BGggt)/($N+$B)) / $BGggt);
		$Sggg = log((($GGG[$i]+$B*$BGggg)/($N+$B)) / $BGggg);
		$Sggc = log((($GGC[$i]+$B*$BGggc)/($N+$B)) / $BGggc);
		$Sgca = log((($GCA[$i]+$B*$BGgca)/($N+$B)) / $BGgca);
		$Sgct = log((($GCT[$i]+$B*$BGgct)/($N+$B)) / $BGgct);
		$Sgcg = log((($GCG[$i]+$B*$BGgcg)/($N+$B)) / $BGgcg);
		$Sgcc = log((($GCC[$i]+$B*$BGgcc)/($N+$B)) / $BGgcc);
		$Scaa = log((($CAA[$i]+$B*$BGcaa)/($N+$B)) / $BGcaa);
		$Scat = log((($CAT[$i]+$B*$BGcat)/($N+$B)) / $BGcat);
		$Scag = log((($CAG[$i]+$B*$BGcag)/($N+$B)) / $BGcag);
		$Scac = log((($CAC[$i]+$B*$BGcac)/($N+$B)) / $BGcac);
		$Scta = log((($CTA[$i]+$B*$BGcta)/($N+$B)) / $BGcta);
		$Sctt = log((($CTT[$i]+$B*$BGctt)/($N+$B)) / $BGctt);
		$Sctg = log((($CTG[$i]+$B*$BGctg)/($N+$B)) / $BGctg);
		$Sctc = log((($CTC[$i]+$B*$BGctc)/($N+$B)) / $BGctc);
		$Scga = log((($CGA[$i]+$B*$BGcga)/($N+$B)) / $BGcga);
		$Scgt = log((($CGT[$i]+$B*$BGcgt)/($N+$B)) / $BGcgt);
		$Scgg = log((($CGG[$i]+$B*$BGcgg)/($N+$B)) / $BGcgg);
		$Scgc = log((($CGC[$i]+$B*$BGcgc)/($N+$B)) / $BGcgc);
		$Scca = log((($CCA[$i]+$B*$BGcca)/($N+$B)) / $BGcca);
		$Scct = log((($CCT[$i]+$B*$BGcct)/($N+$B)) / $BGcct);
		$Sccg = log((($CCG[$i]+$B*$BGccg)/($N+$B)) / $BGccg);
		$Sccc  = log((($CCC [$i]+$B*$BGccc )/($N+$B)) / $BGccc );
		printf OUT "%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\t%.4f\n", $Saaa, $Saat, $Saag, $Saac, $Sata, $Satt, $Satg, $Satc, $Saga, $Sagt, $Sagg, $Sagc, $Saca, $Sact, $Sacg, $Sacc, $Staa, $Stat, $Stag, $Stac, $Stta, $Sttt, $Sttg, $Sttc, $Stga, $Stgt, $Stgg, $Stgc, $Stca, $Stct, $Stcg, $Stcc, $Sgaa, $Sgat, $Sgag, $Sgac, $Sgta, $Sgtt, $Sgtg, $Sgtc, $Sgga, $Sggt, $Sggg, $Sggc, $Sgca, $Sgct, $Sgcg, $Sgcc, $Scaa, $Scat, $Scag, $Scac, $Scta, $Sctt, $Sctg, $Sctc, $Scga, $Scgt, $Scgg, $Scgc, $Scca, $Scct, $Sccg, $Sccc ;
#		print OUT "0\t0\t0\t0\n" if($fg[$i] == 1);
		$Saaa = $Saat = $Saag = $Saac = $Sata = $Satt = $Satg = $Satc = $Saga = $Sagt = $Sagg = $Sagc = $Saca = $Sact = $Sacg = $Sacc = $Staa = $Stat = $Stag = $Stac = $Stta = $Sttt = $Sttg = $Sttc = $Stga = $Stgt = $Stgg = $Stgc = $Stca = $Stct = $Stcg = $Stcc = $Sgaa = $Sgat = $Sgag = $Sgac = $Sgta = $Sgtt = $Sgtg = $Sgtc = $Sgga = $Sggt = $Sggg = $Sggc = $Sgca = $Sgct = $Sgcg = $Sgcc = $Scaa = $Scat = $Scag = $Scac = $Scta = $Sctt = $Sctg = $Sctc = $Scga = $Scgt = $Scgg = $Scgc = $Scca = $Scct = $Sccg = $Sccc = 0;
	}
	
#	print OUT "//\n";
	$N = $B = 0;

}