#!/usr/local/bin/python 
###
# calculate 2nd-order Mrakov model
#	base order : ACGT
###
from Numeric import *

BG={}
#Background probabilit in Ecoli: 0th order Markov Model
BG["A"] = 0.2461
BG["C"] = 0.2539
BG["G"] = 0.2539
BG["T"] = 0.2461
#Background probabilit in Ecoli: 1st order Markov Model
BG["AA"] = 0.0730
BG["AC"] = 0.0552
BG["AG"] = 0.0511
BG["AT"] = 0.0668
BG["CA"] = 0.0698
BG["CC"] = 0.0584
BG["CG"] = 0.0747
BG["CT"] = 0.0511
BG["GA"] = 0.0576
BG["GC"] = 0.0827
BG["GG"] = 0.0584
BG["GT"] = 0.0552
BG["TA"] = 0.0457
BG["TC"] = 0.0576
BG["TG"] = 0.0698
BG["TT"] = 0.0730


#initialization
N = {}
S = {}
for x in "ACGT":
	N[x] = zeros(32,Float)
	S[x] = zeros(32,Float)
	for y in "ACGT":
		N[x+y] = zeros(32,Float)
		S[x+y] = zeros(32,Float)

outfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_matrix/align_up30_1st.txt","w")
#outfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_matrix/align_dw20_1st.txt","w")
nexfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_nex/align_up32.nex","r")
#nexfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_nex/align_dw22.nex","r")
nexdata = nexfile.readlines()
nexdata = nexdata[8:-4]

for i in range (len(nexdata)):
	nexdata[i] = nexdata[i].replace("\n","")
	nexdata[i] = nexdata[i].replace("\t","")
	nexdata[i] = nexdata[i].split(" ")
	for j in range(len(nexdata[i][1])-1):
		
		for x in "ACGT":
			if(nexdata[i][1][j] == x):
				N[x][j] += 1
			for y in "ACGT":
				if(nexdata[i][1][j:j+2] == x+y):
					N[x+y][j] += 1

tnum = len(nexdata)
#B = sqrt(tnum)
B = 1
printnum = ""
printout = ""
for i in range(len(nexdata[0][1])-1)[1:]:	#[1:] : bacause original file is for 2nd order
	for x in "ACGT":
		S[x][i] = log(((N[x][i]+B*BG[x])/(tnum+B)) / BG[x])
#		print x,S[x][i],(N[x][i]+B*BG[x])/(tnum+B),BG[x],log(((N[x][i]+B*BG[x])/(tnum+B)) / BG[x]),BG[x]
		for y in "ACGT":
			S[x+y][i] = log(((N[x+y][i]+B*BG[x+y])/(tnum+B)) / BG[x+y]) - S[x][i]
#			print x+y,S[x+y][i],"=",log(((N[x+y][i]+B*BG[x+y])/(tnum+B))/BG[x+y]),S[x][i],BG[x+y]
			printnum = printnum + "%d\t" % (N[x+y][i])
			printout = printout + "%.4f\t" % (S[x+y][i])
	printnum = printnum[:-1]
	printnum = printnum+ "\n"
	printout = printout[:-1]	#remove the last tab(\t)
	printout = printout + "\n"
printnum = printnum+ "\n"
printout = printout[:-1]	#remove the last return(\n)
#outfile.write(printnum)
outfile.write(printout)
